Index: engines/sword1/animation.cpp
===================================================================
--- engines/sword1/animation.cpp	(revision 26649)
+++ engines/sword1/animation.cpp	(working copy)
@@ -405,7 +405,7 @@
 
 	char filename[20];
 	snprintf(filename, sizeof(filename), "%s.dxa", sequenceList[id]);
-	if (loadFile(filename)) {
+	if (loadFile(filename, 640, 480)) {
 		// The Broken Sword games always use external audio tracks.
 		if (_fd.readUint32BE() != MKID_BE('NULL'))
 			return false;
Index: engines/sword2/animation.cpp
===================================================================
--- engines/sword2/animation.cpp	(revision 26649)
+++ engines/sword2/animation.cpp	(working copy)
@@ -510,7 +510,9 @@
 
 	snprintf(filename, sizeof(filename), "%s.dxa", _name);
 
-	if (loadFile(filename)) {
+	if (loadFile(filename,
+			_vm->_screen->getScreenWide(),
+			_vm->_screen->getScreenDeep())) {
 		// The Broken Sword games always use external audio tracks.
 		if (_fd.readUint32BE() != MKID_BE('NULL'))
 			return false;
Index: engines/agos/animation.cpp
===================================================================
--- engines/agos/animation.cpp	(revision 26649)
+++ engines/agos/animation.cpp	(working copy)
@@ -62,7 +62,9 @@
 	// Change file extension to dxa
 	sprintf(videoName, "%s.dxa", baseName);
 
-	if (!loadFile(videoName)) {
+	if (!loadFile(videoName,
+			_vm->_screen->getScreenWide(),
+			_vm->_screen->getScreenDeep())) {
 		// Check short filename to work around
 		// bug in a German Windows 2CD version.
 		if (baseLen >= 8) {
Index: graphics/dxa_player.cpp
===================================================================
--- graphics/dxa_player.cpp	(revision 26649)
+++ graphics/dxa_player.cpp	(working copy)
@@ -29,6 +29,24 @@
 #include <zlib.h>
 #endif
 
+static void scaleUpBy2(byte *dst, byte *src, uint16 width, uint16 h) {
+  uint16 x;
+
+  while (h > 0)
+  {
+    for (x=width; x>0; x--)
+    {
+      register byte v;
+      v = *src++;
+      *dst++ = v;
+      *dst++ = v;
+    }
+    memcpy(dst, dst-width*2, width*2);
+    dst += width*2;
+    h--;
+  }
+}
+
 namespace Graphics {
 
 DXAPlayer::DXAPlayer() {
@@ -36,6 +54,7 @@
 	_frameBuffer2 = 0;
 	_scaledBuffer = 0;
 	_drawBuffer = 0;
+	_scaledBuffer2 = 0;
 
 	_width = 0;
 	_height = 0;
@@ -48,6 +67,8 @@
 	_frameTicks = 0;
 
 	_scaleMode = S_NONE;
+
+	_scaling = 1;
 }
 
 DXAPlayer::~DXAPlayer() {
@@ -56,13 +77,13 @@
 int DXAPlayer::getWidth() {
 	if (!_fd.isOpen())
 		return 0;
-	return _width;
+	return _width*_scaling;
 }
 
 int DXAPlayer::getHeight() {
 	if (!_fd.isOpen())
 		return 0;
-	return _height;
+	return _height*_scaling;
 }
 
 int DXAPlayer::getCurFrame() {
@@ -77,6 +98,26 @@
 	return _framesCount;
 }
 
+bool DXAPlayer::loadFile(const char *filename, uint16 maxWidth, uint16 maxHeight) {
+	bool result = loadFile(filename);
+
+	if (result)
+	{
+		_scaling = MIN(maxWidth/_width, maxHeight/_height);
+		if (_scaling < 1)
+			_scaling = 1;
+		if (_scaling > 2)
+			_scaling = 2;
+		if (_scaling >= 2)
+		{
+			_scaledBuffer2 = (uint8 *)malloc(_width*_height*_scaling*_scaling);
+			if (!_scaledBuffer2) {
+				_scaling = 1;
+			}
+		}
+	}
+	return result;
+}
 bool DXAPlayer::loadFile(const char *filename) {
 	uint32 tag;
 	int32 frameRate;
@@ -147,6 +188,7 @@
 	free(_frameBuffer1);
 	free(_frameBuffer2);
 	free(_scaledBuffer);
+	free(_scaledBuffer2);
 }
 
 void DXAPlayer::copyFrameToBuffer(byte *dst, uint x, uint y, uint pitch) {
@@ -535,6 +577,12 @@
 		_drawBuffer = _frameBuffer1;
 		break;
 	}
+
+	if (_scaling == 2) {
+		/* Scale up here */
+		scaleUpBy2(_scaledBuffer2, _drawBuffer, _width, _height);
+		_drawBuffer = _scaledBuffer2;
+	}
 }
 
 } // End of namespace Graphics
Index: graphics/dxa_player.h
===================================================================
--- graphics/dxa_player.h	(revision 26649)
+++ graphics/dxa_player.h	(working copy)
@@ -46,6 +46,7 @@
 	byte *_frameBuffer2;
 	byte *_scaledBuffer;
 	byte *_drawBuffer;
+	byte *_scaledBuffer2;
 	uint16 _width;
 	uint16 _height, _curHeight;
 	uint16 _framesCount;
@@ -55,6 +56,7 @@
 	uint16 _frameSkipped;
 	uint32 _frameTicks;
 	ScaleMode _scaleMode;
+	uint32 _scaling;
 
 public:
 	DXAPlayer();
@@ -91,6 +93,14 @@
 	bool loadFile(const char *filename);
 
 	/**
+	 * Load a DXA encoded video file and setup scaling if required
+	 * @param filename	the filename to load
+	 * @param maxWidth      the maximum width  available to the film
+	 * @param maxHeight     the maximum height available to the film
+	 */
+	bool loadFile(const char *filename, uint16 maxWidth, uint16 maxHeight);
+
+	/**
 	 * Close a DXA encoded video file
 	 */
 	void closeFile();