--- README	2007-08-18 15:08:03.000000000 +0200
+++ README.TXT.new	2007-08-17 14:09:33.000000000 +0200
@@ -1,5 +1,5 @@
 ScummVM README
-Last updated:    $Date: 2007-07-25 22:12:41 +0200 (Wed, 25 Jul 2007) $
+Last updated:    $Date$
 ------------------------------------------------------------------------
 
 TODO: Resolve all the TODOs scattered through this file before release.
@@ -170,7 +170,7 @@
          - Swampy Adventures                     [swampy]
      The Feeble Files                            [feeble]
 
-GOB Games by Cocktel Vision:
+GOB Games by Coktel Vision:
      Bargon Attack                               [bargon]
      Gobliiins                                   [gob1]
      Gobliins 2                                  [gob2]
@@ -296,7 +296,7 @@
 should be able to automatically detect the game if you point it at the
 right directory.
 
-Alternatively, you can use extract_mm_c64 from the tools package to
+Alternatively, you can use 'extract_mm_c64' from the tools package to
 extract the data files. But then the game will not be properly
 autodetected by ScummVM, and you must make sure that the platform is
 set to Commodore64. We recommend using the much simpler approach
@@ -346,7 +346,7 @@
 simply point ScummVM at the directory containing it, and it should work (just like
 with every other supported game).
 
-We also provide a tool called 'rescumm' in the tools package to extract the
+We also provide a tool called 'extract_scumm_mac' in the tools package to extract the
 data from these data files, but this is neither required nor recommended.
 
 For further information on copying Macintosh game files to your hard disk see:
@@ -400,12 +400,12 @@
 These cutscenes are provided in DXA format with FLAC audio. Their quality
 is equal to the original games due to the use of lossless compression.
 Viewing these cutscenes requires a version of ScummVM compiled with both
-FLAC and zLib support.
+FLAC and zlib support.
 
 For systems that are too slow to handle the decoding of FLAC audio,
 the audio for these cutscenes is provided separately as OGG Vorbis audio
 too. Viewing these cutscenes with OGG Vorbis audio requires a version of
-ScummVM compiled with both libVorbis and zLib support. 
+ScummVM compiled with both libVorbis and zlib support. 
 
 The cutscenes should be placed in the main game data directory. Note that
 currently this requires either copying the game to hard disk or burning
@@ -790,10 +790,10 @@
                            Steel Sky and Flight of the Amazon Queen
   --copy-protection        Enable copy protection in games, when
                            ScummVM disables it by default.
+  --talkspeed=NUM          Set talk speed for games (default: 60)
   --demo-mode              Start demo mode of Maniac Mansion (Classic version)
   --tempo=NUM              Set music tempo (in percent, 50-200) for SCUMM games
                            (default: 100)
-  --talkspeed=NUM          Set talk speed for games
 
 
 The meaning of most long options (that is, those options starting with a
@@ -832,6 +832,10 @@
 but rather is only used to select the appropriate font (e.g. for a German
 version of a game, one containing umlauts).
 
+An exception are The Dig and The Curse of Monkey Island - non-English versions
+can be set to 'English.' This however only affects subtitles; game speech will
+remain the same.
+
 Maniac Mansion and Zak McKracken
         en  - English (default)
         de  - German
@@ -933,7 +937,7 @@
 ---- ---------
 TODO
 TODO: Rework this section to clearly state which hotkeys are implemented in *all*
-TODO  game (and for which backends).
+TODO  games (and for which backends).
 TODO: It would also be nice to add information about control on devices w/o a keyboard;
 TODO  I.e. document how input on DC, DS, PSP, PS2, PalmOS, WinCE, ... works for each game
 TODO  Or at the very least give points as to were one can read up on these.
@@ -1077,7 +1081,7 @@
         t                      - Switch between 'Voice only',
                                  'Voice and Text' and 'Text only'
 
-Note that using ctrl-f or ctrl-g is not recommended: games can crash when
+Note that using Ctrl-f or Ctrl-g is not recommended: games can crash when
 being run faster than their normal speed, as scripts will lose synchronisation.
 
 Note for WinCE users: Due to the limited keyboard input in most devices, a
@@ -1189,7 +1193,7 @@
 ---- ----------------------------------
 Some games (such as Sam & Max) only contain MIDI music data.  This once
 prevented music for these games from working on platforms that do not support
-MIDI, or soundcards that do not provide MIDI drivers (e.g, many soundcards will
+MIDI, or soundcards that do not provide MIDI drivers (e.g. many soundcards will
 not play MIDI under Linux). ScummVM can now emulate MIDI mode using sampled
 waves and Adlib, FluidSynth MIDI emulation or MT-32 emulation using the
 -eadlib, -efluidsynth or -emt32 options respectively.  However, if you are
@@ -1339,7 +1343,7 @@
 
 7.7.3) Compressing MONSTER.SOU with MP3:
 ------ ---------------------------------
-You need LAME, and our compress_scumm_sou utility from the scummvm-tools
+You need LAME, and our 'compress_scumm_sou' utility from the scummvm-tools
 package to perform this task, and ScummVM must be compiled with MAD support.
 
   compress_scumm_sou monster.sou
@@ -1375,7 +1379,7 @@
 
 7.7.6) Compressing music/sfx/speech in AGOS games
 ------ -----------------------------------------------------------------
-Use our compress_agos utility from the scummvm-tools package to perform this
+Use our 'compress_agos' utility from the scummvm-tools package to perform this
 task. You can choose between multiple target formats, but note that you can
 only use each if ScummVM was compiled with the respective decoder support
 enabled.
@@ -1410,7 +1414,7 @@
 
 7.7.7) Compressing speech/music in Broken Sword 1
 ------ ------------------------------------------
-The compress_sword1 tool from the scummvm-tools package can encode music and
+The 'compress_sword1' tool from the scummvm-tools package can encode music and
 speech to MP3 as well as Ogg Vorbis.
 The easiest way to encode the files is simply copying the executable into your
 BS1 directory (together with the lame encoder) and run it from there.
@@ -1429,7 +1433,7 @@
 
 7.7.8) Compressing speech/music in Broken Sword 2
 ------ ------------------------------------------
-Use our compress_sword2 utility from the scummvm-tools package to perform this
+Use our 'compress_sword2' utility from the scummvm-tools package to perform this
 task. You can choose between multiple target formats, but note  that you can
 only use each if ScummVM was compiled with the respective decoder support
 enabled.